#!/usr/bin/python

import Headweb
import mc
from xml.dom import minidom
import urllib, urllib2

# Create the global HW API object that will be used.
api = Headweb.APIv3('http://api.headweb.com', '86cc9ddac31d11dea3d733b0e449c0be')
def urlcode (url):
	url = url.replace(':', '%3A')
	url = url.replace('/', '%2F')
	url = url.replace('&', '%26')
	return url

def onSearchClick ():
	mc.ShowDialogWait()
	mc.LogDebug("Headweb: onSearchClick() called.")
	
	searchString = mc.GetActiveWindow().GetEdit(222).GetText()
	searchString = searchString.strip()
	parser = api.search(searchString, fields="stream,cover,name")
	mc.HideDialogWait()
	mc.ShowDialogNotification('Search complete, ' + str(parser.response.list['items']) + ' results.')
	
	listItems = mc.ListItems()
	
	contentNodes = parser.response.list.findAll('content', recursive=False)
	
	for contentNode in contentNodes:
		listItem = mc.ListItem(mc.ListItem.MEDIA_VIDEO_CLIP)
		try:
			label = contentNode.findAll('name', recursive=False, limit=1)[0].string
		except:
			label = 'Inget namn'
		
		runtime = 0
		protocol = 'none://'
		streamID = 0
		try:
			stream = contentNode.findAll('stream', recursive=False, limit=1)[0]
			streamID = stream['id']
			if stream.type.string == 'flash':
				protocol = 'flash://'
			elif stream.type.string == 'silverlight':
				protocol = 'flash://'
			runtime = int(stream.runtime.string)
		except:
			mc.ShowDialogNotification('Item has no stream element.')
		
		
		path = protocol + 'headweb.com/src=' + urlcode(api.stream(streamID, 'player')) + '&bx-jsactions=' + urlcode('http://xarragon.terminal.se/headweb/headweb.js')
		try:
			cover = contentNode.findAll('cover', recursive=False, limit=1)[0].string
		except:
			cover = ''
		listItem.SetContentType("application/x-shockwave-flash")
		listItem.SetLabel(unicode(label).encode('utf-8'))
		listItem.SetTitle(unicode(label).encode('utf-8'))
		listItem.SetProviderSource('Headweb On-Demand Video')
		listItem.SetThumbnail(unicode(cover).encode('utf-8'))
		listItem.SetPath(unicode(path).encode('utf-8'))
		listItem.SetDuration(runtime)
		
		listItems.append(listItem)
	
	listControl = mc.GetActiveWindow().GetList(260)
	listControl.SetItems(listItems)

def onMainListClick ():
	mc.ShowDialogNotification('Main list click.')

